Loading...
Searching...
No Matches
juce::PopupMenu::Options Class Reference

## Detailed Description

Class used to create a set of options to pass to the show() method.

You can chain together a series of calls to this class's methods to create a set of whatever options you want to specify. E.g.

PopupMenu menu;
...
menu.showMenu (PopupMenu::Options().withMinimumWidth (100)
.withMaximumNumColumns (3)
.withTargetComponent (myComp));

The documentation for this class was generated from the following file:

- juce_gui_basics/menus/juce_PopupMenu.h

## Public Types

enum class | PopupDirection { upwards , downwards }

## Public Member Functions

| Options ()
| By default, the target screen area will be the current mouse position.
| Options (const Options &)=default
Options & | operator= (const Options &)=default
Options | withTargetComponent (Component *targetComponent) const
| Sets the target component to use when displaying the menu.
Options | withTargetComponent (Component &targetComponent) const
Options | withTargetScreenArea (Rectangle< int > targetArea) const
| Sets the region of the screen next to which the menu should be displayed.
Options | withMousePosition () const
| Sets the target screen area to match the current mouse position.
Options | withDeletionCheck (Component &componentToWatchForDeletion) const
| If the passed component has been deleted when the popup menu exits, the selected item's action will not be called.
Options | withMinimumWidth (int minWidth) const
| Sets the minimum width of the popup window.
Options | withMinimumNumColumns (int minNumColumns) const
| Sets the minimum number of columns in the popup window.
Options | withMaximumNumColumns (int maxNumColumns) const
| Sets the maximum number of columns in the popup window.
Options | withStandardItemHeight (int standardHeight) const
| Sets the default height of each item in the popup menu.
Options | withItemThatMustBeVisible (int idOfItemToBeVisible) const
| Sets an item which must be visible when the menu is initially drawn.
Options | withParentComponent (Component *parentComponent) const
| Sets a component that the popup menu will be drawn into.
Options | withPreferredPopupDirection (PopupDirection direction) const
| Sets the direction of the popup menu relative to the target screen area.
Options | withInitiallySelectedItem (int idOfItemToBeSelected) const
| Sets an item to select in the menu.
Options | forSubmenu () const
| Returns a copy of these options with the target component set to null.
Component * | getParentComponent () const noexcept
| Gets the parent component.
Component * | getTargetComponent () const noexcept
| Gets the target component.
Component * | getTopLevelTargetComponent () const noexcept
| Gets the target component that was set for the top-level menu.
bool | hasWatchedComponentBeenDeleted () const noexcept
| Returns true if the menu was watching a component, and that component has been deleted, and false otherwise.
Rectangle< int > | getTargetScreenArea () const noexcept
| Gets the target screen area.
int | getMinimumWidth () const noexcept
| Gets the minimum width.
int | getMaximumNumColumns () const noexcept
| Gets the maximum number of columns.
int | getMinimumNumColumns () const noexcept
| Gets the minimum number of columns.
int | getStandardItemHeight () const noexcept
| Gets the default height of items in the menu.
int | getItemThatMustBeVisible () const noexcept
| Gets the ID of the item that must be visible when the menu is initially shown.
PopupDirection | getPreferredPopupDirection () const noexcept
| Gets the preferred popup menu direction.
int | getInitiallySelectedItemId () const noexcept
| Gets the ID of the item that must be selected when the menu is initially shown.

## Member Enums

## PopupDirection

enum class juce::PopupMenu::Options::PopupDirection

strong

Enumerator
upwards |
downwards |

## Constructors and Destructors

## Options() [1/2]

juce::PopupMenu::Options::Options | ( |  | ) |

By default, the target screen area will be the current mouse position.

Referenced by forSubmenu(), operator=(), Options(), withDeletionCheck(), withInitiallySelectedItem(), withItemThatMustBeVisible(), withMaximumNumColumns(), withMinimumNumColumns(), withMinimumWidth(), withMousePosition(), withParentComponent(), withPreferredPopupDirection(), withStandardItemHeight(), withTargetComponent(), withTargetComponent(), and withTargetScreenArea().

## Options() [2/2]

juce::PopupMenu::Options::Options | ( | const Options & |  | ) |

default

References Options().

## Member Functions

## operator=()

Options & juce::PopupMenu::Options::operator= | ( | const Options & |  | ) |

default

References Options().

## withTargetComponent() [1/2]

Options juce::PopupMenu::Options::withTargetComponent | ( | Component * | targetComponent | ) | const

nodiscard

Sets the target component to use when displaying the menu.

This is normally the button or other control that triggered the menu.

The target component is primarily used to control the scale of the menu, so it's important to supply a target component if you'll be using your program on hi-DPI displays.

This function will also set the target screen area, so that the menu displays next to the target component. If you need to display the menu at a specific location, you should call withTargetScreenArea() after withTargetComponent.

See also
  withTargetComponent, withTargetScreenArea

References Options().

## withTargetComponent() [2/2]

Options juce::PopupMenu::Options::withTargetComponent | ( | Component & | targetComponent | ) | const

nodiscard

References Options().

## withTargetScreenArea()

Options juce::PopupMenu::Options::withTargetScreenArea | ( | Rectangle< int > | targetArea | ) | const

nodiscard

Sets the region of the screen next to which the menu should be displayed.

To display the menu next to the mouse cursor use withMousePosition(), which is equivalent to passing the following to this function:

Rectangle<int>{}.withPosition (Desktop::getMousePosition())
juce::Desktop::getMousePosition
static Point< int > getMousePosition()
Returns the mouse position.
juce::Rectangle
Manages a rectangle and allows geometric operations to be performed on it.
Definition juce_Rectangle.h:74
juce::Rectangle::withPosition
Rectangle withPosition(ValueType newX, ValueType newY) const noexcept
Returns a rectangle with the same size as this one, but a new position.
Definition juce_Rectangle.h:239

withTargetComponent() will also set the target screen area. If you need a target component and a target screen area, make sure to call withTargetScreenArea() after withTargetComponent().

See also
  withMousePosition

References Options().

## withMousePosition()

Options juce::PopupMenu::Options::withMousePosition | ( |  | ) | const

nodiscard

Sets the target screen area to match the current mouse position.

Make sure to call this after withTargetComponent().

See also
  withTargetScreenArea

References Options().

## withDeletionCheck()

Options juce::PopupMenu::Options::withDeletionCheck | ( | Component & | componentToWatchForDeletion | ) | const

nodiscard

If the passed component has been deleted when the popup menu exits, the selected item's action will not be called.

This is useful for avoiding dangling references inside the action callback, in the case that the callback needs to access a component that may be deleted.

References Options().

## withMinimumWidth()

Options juce::PopupMenu::Options::withMinimumWidth | ( | int | minWidth | ) | const

nodiscard

Sets the minimum width of the popup window.

References Options().

## withMinimumNumColumns()

Options juce::PopupMenu::Options::withMinimumNumColumns | ( | int | minNumColumns | ) | const

nodiscard

Sets the minimum number of columns in the popup window.

References Options().

## withMaximumNumColumns()

Options juce::PopupMenu::Options::withMaximumNumColumns | ( | int | maxNumColumns | ) | const

nodiscard

Sets the maximum number of columns in the popup window.

References Options().

## withStandardItemHeight()

Options juce::PopupMenu::Options::withStandardItemHeight | ( | int | standardHeight | ) | const

nodiscard

Sets the default height of each item in the popup menu.

References Options().

## withItemThatMustBeVisible()

Options juce::PopupMenu::Options::withItemThatMustBeVisible | ( | int | idOfItemToBeVisible | ) | const

nodiscard

Sets an item which must be visible when the menu is initially drawn.

This is useful to ensure that a particular item is shown when the menu contains too many items to display on a single screen.

The specified item will be positioned at the target screen area of the menu if possible.

References Options().

## withParentComponent()

Options juce::PopupMenu::Options::withParentComponent | ( | Component * | parentComponent | ) | const

nodiscard

Sets a component that the popup menu will be drawn into.

Some plugin formats, such as AUv3, dislike it when the plugin editor spawns additional windows. Some AUv3 hosts display pink backgrounds underneath transparent popup windows, which is confusing and can appear as though the plugin is malfunctioning. Setting a parent component will avoid this unwanted behaviour, but with the downside that the menu size will be constrained by the size of the parent component.

References Options().

## withPreferredPopupDirection()

Options juce::PopupMenu::Options::withPreferredPopupDirection | ( | PopupDirection | direction | ) | const

nodiscard

Sets the direction of the popup menu relative to the target screen area.

References Options().

## withInitiallySelectedItem()

Options juce::PopupMenu::Options::withInitiallySelectedItem | ( | int | idOfItemToBeSelected | ) | const

nodiscard

Sets an item to select in the menu.

This is useful for controls such as combo boxes, where opening the combo box with the keyboard should ideally highlight the currently-selected item, allowing the next/previous item to be selected by pressing up/down on the keyboard, rather than needing to move the highlighted row down from the top of the menu each time it is opened.

References Options().

## forSubmenu()

Options juce::PopupMenu::Options::forSubmenu | ( |  | ) | const

nodiscard

Returns a copy of these options with the target component set to null.

The value of the top-level target component will not be changed.

See also
  getTargetComponent(), getTopLevelTargetComponent()

References Options().

## getParentComponent()

Component * juce::PopupMenu::Options::getParentComponent | ( |  | ) | const

inline noexcept

Gets the parent component.

This may be nullptr if the Component has been deleted.

See also
  withParentComponent

## getTargetComponent()

Component * juce::PopupMenu::Options::getTargetComponent | ( |  | ) | const

inline noexcept

Gets the target component.

This may be nullptr if the Component has been deleted.

See also
  withTargetComponent

## getTopLevelTargetComponent()

Component * juce::PopupMenu::Options::getTopLevelTargetComponent | ( |  | ) | const

inline noexcept

Gets the target component that was set for the top-level menu.

When querying the options of a submenu, getTargetComponent() will always return nullptr, while getTopLevelTargetComponent() will return the target passed to withTargetComponent() when creating the top-level menu.

## hasWatchedComponentBeenDeleted()

bool juce::PopupMenu::Options::hasWatchedComponentBeenDeleted | ( |  | ) | const

inline noexcept

Returns true if the menu was watching a component, and that component has been deleted, and false otherwise.

See also
  withDeletionCheck

## getTargetScreenArea()

Rectangle< int > juce::PopupMenu::Options::getTargetScreenArea | ( |  | ) | const

inline noexcept

Gets the target screen area.

See also
  withTargetScreenArea

## getMinimumWidth()

int juce::PopupMenu::Options::getMinimumWidth | ( |  | ) | const

inline noexcept

Gets the minimum width.

See also
  withMinimumWidth

## getMaximumNumColumns()

int juce::PopupMenu::Options::getMaximumNumColumns | ( |  | ) | const

inline noexcept

Gets the maximum number of columns.

See also
  withMaximumNumColumns

## getMinimumNumColumns()

int juce::PopupMenu::Options::getMinimumNumColumns | ( |  | ) | const

inline noexcept

Gets the minimum number of columns.

See also
  withMinimumNumColumns

## getStandardItemHeight()

int juce::PopupMenu::Options::getStandardItemHeight | ( |  | ) | const

inline noexcept

Gets the default height of items in the menu.

See also
  withStandardItemHeight

## getItemThatMustBeVisible()

int juce::PopupMenu::Options::getItemThatMustBeVisible | ( |  | ) | const

inline noexcept

Gets the ID of the item that must be visible when the menu is initially shown.

See also
  withItemThatMustBeVisible

## getPreferredPopupDirection()

PopupDirection juce::PopupMenu::Options::getPreferredPopupDirection | ( |  | ) | const

inline noexcept

Gets the preferred popup menu direction.

See also
  withPreferredPopupDirection

## getInitiallySelectedItemId()

int juce::PopupMenu::Options::getInitiallySelectedItemId | ( |  | ) | const

inline noexcept

Gets the ID of the item that must be selected when the menu is initially shown.

See also
  withItemThatMustBeVisible

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited